﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Amöben
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<Lebewesen> zoo = new List<Lebewesen>();

        System.Windows.Threading.DispatcherTimer uhr = new System.Windows.Threading.DispatcherTimer();

        public MainWindow()
        {
            InitializeComponent();

            uhr.Interval = TimeSpan.FromSeconds(0.1);
            uhr.Tick += animiere;
            uhr.Start();

            for (int i = 0; i < 20; i++)
            {
                zoo.Add(new Amöbe());
            }

            for (int i = 0; i < 10; i++)
            {
                zoo.Add(new Bakterium());
            }
        }

        void animiere(object sender, EventArgs e)
        {
            Petrischale.Children.Clear();
            List<Lebewesen> kindergarten = new List<Lebewesen>();
            List<Lebewesen> gefressen = new List<Lebewesen>();
            foreach (Lebewesen item in zoo)
            {
                if (!gefressen.Contains(item))
                {
                    item.Bewege();
                    kindergarten.AddRange(item.Vermehre());
                    item.Zeichne(Petrischale);
                    gefressen.AddRange(item.Friss(zoo));
                }
            }
            zoo.AddRange(kindergarten);
            // mit foreach:
            //foreach (Lebewesen u in gefressen)
            //{
            //    zoo.Remove(u);
            //}
            // mit for:
            //for (int i = 0; i < gefressen.Count; i++)
            //{
            //    zoo.Remove(gefressen[i]);
            //}
            zoo.RemoveAll(x => gefressen.Contains(x));
        }
    }
}
